%global namedreltag .Final
%global namedversion %{version}%{?namedreltag}

%if 0%{?fedora}
# https://bugzilla.redhat.com/show_bug.cgi?id=1181081
%bcond_with wildfly
%bcond_with jetty9
%endif

Name:          keycloak
Version:       2.4.0
Release:       1%{?dist}
Summary:       Java Identity and Access Management for Applications and Services
License:       ASL 2.0
URL:           http://keycloak.jboss.org/
Source0:       https://github.com/keycloak/keycloak/archive/%{namedversion}/%{name}-%{namedversion}.tar.gz

# https://issues.jboss.org/projects/KEYCLOAK/issues/KEYCLOAK-3440
Patch0:        keycloak-2.3.0-unclosed-transactions.patch
# Add missing method
Patch1:        keycloak-2.3.0-port-model-jpa-to-liquibase-3.5.3.patch

BuildRequires: closure-compiler
BuildRequires: maven-local
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-annotations)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-core)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires: mvn(com.google.zxing:javase)
BuildRequires: mvn(com.h2database:h2)
BuildRequires: mvn(io.undertow:undertow-core)
BuildRequires: mvn(io.undertow:undertow-servlet)
BuildRequires: mvn(javax.mail:javax.mail-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(log4j:log4j:1.2.17)
BuildRequires: mvn(net.java.dev.jna:jna)
BuildRequires: mvn(org.apache.directory.api:api-ldap-codec-standalone)
BuildRequires: mvn(org.apache.directory.server:apacheds-core-annotations)
BuildRequires: mvn(org.apache.directory.server:apacheds-interceptor-kerberos)
BuildRequires: mvn(org.apache.directory.server:apacheds-server-annotations)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.santuario:xmlsec)
BuildRequires: mvn(org.apache.tomcat:tomcat-catalina)
BuildRequires: mvn(org.apache.tomcat:tomcat-servlet-api)
BuildRequires: mvn(org.bouncycastle:bcpkix-jdk15on)
BuildRequires: mvn(org.bouncycastle:bcprov-jdk15on)
BuildRequires: mvn(org.eclipse.jetty:jetty-security:8.1)
BuildRequires: mvn(org.eclipse.jetty:jetty-server:8.1)
BuildRequires: mvn(org.eclipse.jetty:jetty-util:8.1)
%if %{with jetty9}
BuildRequires: mvn(org.eclipse.jetty:jetty-security:9.3.9.v20160517)
BuildRequires: mvn(org.eclipse.jetty:jetty-server:9.3.9.v20160517)
BuildRequires: mvn(org.eclipse.jetty:jetty-util:9.3.9.v20160517)
%endif
BuildRequires: mvn(org.freemarker:freemarker)
BuildRequires: mvn(org.hibernate:hibernate-entitymanager)
BuildRequires: mvn(org.hibernate.javax.persistence:hibernate-jpa-2.1-api)
%if %{?fedora} >= 25
BuildRequires: mvn(org.infinispan:infinispan-core) >= 8.1.0
%endif
BuildRequires: mvn(org.jboss:jboss-parent:pom:)
BuildRequires: mvn(org.jboss.aesh:aesh)
BuildRequires: mvn(org.jboss.logging:jboss-logging)
BuildRequires: mvn(org.jboss.logging:jboss-logging-annotations)
BuildRequires: mvn(org.jboss.logging:jboss-logging-processor)
BuildRequires: mvn(org.jboss.resteasy:resteasy-client)
BuildRequires: mvn(org.jboss.resteasy:resteasy-jackson2-provider)
BuildRequires: mvn(org.jboss.resteasy:resteasy-jaxrs)
BuildRequires: mvn(org.jboss.resteasy:resteasy-multipart-provider)
BuildRequires: mvn(org.jboss.spec.javax.servlet:jboss-servlet-api_3.0_spec)
BuildRequires: mvn(org.jboss.spec.javax.transaction:jboss-transaction-api_1.2_spec)
BuildRequires: mvn(org.jboss.spec.javax.ws.rs:jboss-jaxrs-api_2.0_spec)
BuildRequires: mvn(org.liquibase:liquibase-core)
BuildRequires: mvn(org.mockito:mockito-all)
BuildRequires: mvn(org.mongodb:mongo-java-driver)
BuildRequires: mvn(org.osgi:org.osgi.core)
BuildRequires: mvn(org.picketbox:picketbox)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-log4j12)
BuildRequires: mvn(org.slf4j:slf4j-simple)
BuildRequires: mvn(org.springframework:spring-test)
BuildRequires: mvn(org.springframework.security:spring-security-config)
BuildRequires: mvn(org.springframework.security:spring-security-web)
%if %{with wildfly}
BuildRequires: mvn(org.wildfly:wildfly-web-common)
BuildRequires: mvn(org.wildfly.core:wildfly-subsystem-test-framework)
%endif
BuildRequires: mvn(org.wildfly.core:wildfly-controller)
BuildRequires: mvn(org.wildfly.core:wildfly-domain-management)

BuildArch:     noarch

%description
Integrated SSO and IDM for browser apps and RESTful web services.
Built on top of the OAuth 2.0, Open ID Connect, JSON Web Token (JWT) and
SAML 2.0 specifications.  Keycloak has tight integration with a variety
of platforms and has a HTTP security proxy service where we don't have tight
integration. Options are to deploy it with an existing app server, as a
black-box appliance, or as an Openshift cloud service and/or cartridge.

%package adapter-core
Summary:       Keycloak Adapter Core

%description adapter-core
Keycloak Adapter Core.

%package adapter-spi
Summary:       Keycloak Adapter SPI

%description adapter-spi
Keycloak Adapter SPI.

%package admin-client
Summary:       Keycloak Admin REST Client

%description admin-client
Keycloak Admin REST Client.

%package authz-client
Summary:       KeyCloak Authz: Client API

%description authz-client
KeyCloak Authz: Client API.

%package authz-policy-common
Summary:       KeyCloak AuthZ: Common Policy Providers

%description authz-policy-common
KeyCloak AuthZ: Common Policy Providers.

%package client-registration-api
Summary:       Keycloak Client Registration API

%description client-registration-api
Keycloak Client Registration API.

%package common
Summary:       Keycloak Common Library

%description common
Common library and dependencies shared with server and
all adapters.

%package core
Summary:       Keycloak Core

%description core
Keycloak Core.

%package installed-adapter
Summary:       Keycloak Installed Application

%description installed-adapter
Keycloak Installed Application.

%package jaxrs-oauth-client
Summary:       Keycloak JAX-RS OAuth Client

%description jaxrs-oauth-client
Keycloak JAX-RS OAuth Client.

%package jboss-adapter-core
Summary:       Common JBoss/Wildfly Core Classes

%description jboss-adapter-core
Common JBoss/Wildfly Core Classes.

%package jetty-adapter-spi
Summary:       Keycloak Jetty Adapter SPI

%description jetty-adapter-spi
Keycloak Jetty Adapter SPI.

%package jetty-core
Summary:       Keycloak Jetty Core Integration

%description jetty-core
Keycloak Jetty Core Integration.

%package jetty81-adapter
Summary:       Keycloak Jetty 8.1.x Integration

%description jetty81-adapter
Keycloak Jetty 8.1.x Integration.

%package kerberos-federation
Summary:       Keycloak Kerberos Federation

%description kerberos-federation
Keycloak Kerberos Federation.

%package ldap-federation
Summary:       Keycloak LDAP Federation

%description ldap-federation
Keycloak LDAP Federation.

%package model-infinispan
Summary:       Keycloak Model Infinispan

%description model-infinispan
Keycloak Model Infinispan.

%package model-jpa
Summary:       Keycloak Model JPA

%description model-jpa
Keycloak Model JPA.

%package model-mongo
Summary:       Keycloak Model Mongo

%description model-mongo
Keycloak Model Mongo.

%package proxy-server
Summary:       Keycloak Proxy Server

%description proxy-server
Keycloak Proxy Server.

%package saml-adapter-api-public
Summary:       Keycloak SAML Client Adapter Public API

%description saml-adapter-api-public
Keycloak SAML Client Adapter Public API.

%package saml-adapter-core
Summary:       Keycloak SAML Client Adapter Core

%description saml-adapter-core
Keycloak SAML Client Adapter Core.

%package saml-core
Summary:       Keycloak SAML Core

%description saml-core
Keycloak SAML Core.

%package saml-core-public
Summary:       Keycloak SAML Core Public API

%description saml-core-public
Keycloak SAML Core Public API.

%package saml-jetty-adapter-core
Summary:       Keycloak Jetty Core SAML Integration

%description saml-jetty-adapter-core
Keycloak Jetty Core SAML Integration.

%package saml-jetty81-adapter
Summary:       Keycloak Jetty 8.1.x SAML Integration

%description saml-jetty81-adapter
Keycloak Jetty 8.1.x SAML Integration.

%package saml-servlet-filter-adapter
Summary:       Keycloak SAML Servlet Filter

%description saml-servlet-filter-adapter
Keycloak SAML Servlet Filter.

%package saml-tomcat-adapter-core
Summary:       Keycloak Tomcat Core SAML Integration

%description saml-tomcat-adapter-core
Keycloak Tomcat Core SAML Integration.

%package saml-tomcat8-adapter
Summary:       Keycloak Tomcat 8 SAML Integration

%description saml-tomcat8-adapter
Keycloak Tomcat 8 SAML Integration.

%package saml-undertow-adapter
Summary:       Keycloak Undertow SAML Adapter

%description saml-undertow-adapter
Keycloak Undertow SAML Adapter.

%package saml-wildfly-adapter
Summary:       Keycloak Wildfly SAML Adapter

%description saml-wildfly-adapter
Keycloak Wildfly SAML Adapter.

%package saml-wildfly-subsystem
Summary:       Keycloak Wildfly SAML Adapter Subsystem

%description saml-wildfly-subsystem
Keycloak Wildfly SAML Adapter Subsystem.

%package server-spi
Summary:       Keycloak Server SPI

%description server-spi
Keycloak Server SPI.

%package server-spi-private
Summary:       Keycloak Server Private SPI

%description server-spi-private
Keycloak Server Private SPI.

%package services
Summary:       Keycloak REST Services

%description services
Keycloak REST Services.

%package servlet-adapter-spi
Summary:       Keycloak Servlet Integration

%description servlet-adapter-spi
Keycloak Servlet Integration.

%package servlet-filter-adapter
Summary:       Keycloak Servlet Filter Adapter Integration

%description servlet-filter-adapter
Keycloak Servlet Filter Adapter Integration.

%package servlet-oauth-client
Summary:       Keycloak Servlet OAuth Client

%description servlet-oauth-client
Keycloak Servlet OAuth Client.

%package spring-security-adapter
Summary:       Keycloak Spring Security Integration

%description spring-security-adapter
Keycloak Spring Security Integration.

%package sssd-federation
Summary:       Keycloak SSSD Federation
License:       ASL 2.0 and (LGPLv2+ or AFL) and MIT
# Unknow versions:
# LGPLv2+ or AFL 2.1: ./federation/sssd/src/main/java/org/freedesktop/dbus
Provides:      bundled(dbus-java)
# MIT: ./federation/sssd/src/main/java/cx/ath/matthew
Provides:      bundled(libmatthew-java)
# MIT: ./federation/sssd/src/main/java/org/jvnet/libpam
Provides:      bundled(libpam4j)

%description sssd-federation
Keycloak SSSD Federation.

%package tomcat-adapter-spi
Summary:       Keycloak Tomcat Adapter SPI

%description tomcat-adapter-spi
Keycloak Tomcat Adapter SPI.

%package tomcat-core-adapter
Summary:       Keycloak Tomcat Core Integration

%description tomcat-core-adapter
Keycloak Tomcat Core Integration.

%package tomcat8-adapter
Summary:       Keycloak Tomcat 8 Integration

%description tomcat8-adapter
Keycloak Tomcat 8 Integration.

%package undertow-adapter
Summary:       Keycloak Undertow Integration

%description undertow-adapter
Keycloak Undertow Integration.

%package undertow-adapter-spi
Summary:       Keycloak Undertow Integration

%description undertow-adapter-spi
Keycloak Undertow Integration.

%package wildfly-adapter
Summary:       Keycloak Wildfly Integration

%description wildfly-adapter
Keycloak Wildfly Integration.

%package wildfly-adduser
Summary:       Keycloak WildFly Add User Script

%description wildfly-adduser
Keycloak WildFly Add User Script.

%package wildfly-extensions
Summary:       Keycloak WildFly Extensions

%description wildfly-extensions
Keycloak WildFly Extensions.

%package wildfly-server-subsystem
Summary:       Keycloak WildFly Server Subsystem

%description wildfly-server-subsystem
Keycloak WildFly Server Subsystem.

%package wildfly-subsystem
Summary:       Keycloak OIDC Wildfly Adapter Subsystem

%description wildfly-subsystem
Keycloak OIDC Wildfly Adapter Subsystem.

%package launcher
Summary:       Keycloak Launcher

%description launcher
Keycloak Launcher.

%package adapters-pom
Summary:       Keycloak Adapters Parent POM

%description adapters-pom
Keycloak Adapters Parent POM.

%package authz-parent
Summary:       KeyCloak AuthZ: Parent POM

%description authz-parent
KeyCloak AuthZ: Parent POM.

%package authz-provider-parent
Summary:       KeyCloak AuthZ: Provider Parent POM

%description authz-provider-parent
KeyCloak AuthZ: Provider Parent POM.

%package client-adapter-spi-pom
Summary:       Keycloak Client Adapter SPI Parent POM

%description client-adapter-spi-pom
Keycloak Client Adapter SPI Parent POM.

%package dependencies-parent
Summary:       Keycloak Dependencies Parent POM

%description dependencies-parent
Keycloak Dependencies Parent POM.

%package dependencies-server-all
Summary:       Keycloak Dependencies Server ALL Parent POM

%description dependencies-server-all
Keycloak Dependencies Server ALL Parent POM.

%package dependencies-server-min
Summary:       Keycloak Dependencies Server MIN Parent POM

%description dependencies-server-min
Keycloak Dependencies Server MIN Parent POM.

%package federation-parent
Summary:       Keycloak Federation Parent POM

%description federation-parent
Keycloak Federation Parent POM.

%package integration-parent
Summary:       Keycloak Integration Parent POM

%description integration-parent
Keycloak Integration Parent POM.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%package jetty-integration-pom
Summary:       Keycloak Jetty Integration Parent POM

%description jetty-integration-pom
Keycloak Jetty Integration Parent POM.

%package model-pom
Summary:       Keycloak Model Parent POM

%description model-pom
Keycloak Model Parent POM.

%package oidc-client-adapter-pom
Summary:       Keycloak OIDC Client Adapter Parent POM

%description oidc-client-adapter-pom
Keycloak OIDC Client Adapter Parent POM.

%package parent
Summary:       Keycloak Parent POM

%description parent
Keycloak Parent POM.

%package proxy-pom
Summary:       Keycloak Proxy Parent POM

%description proxy-pom
Keycloak Proxy Parent POM.

%package saml-client-adapter-pom
Summary:       Keycloak SAML Client Adapter Parent POM

%description saml-client-adapter-pom
Keycloak SAML Client Adapter Parent POM.

%package saml-jetty-integration-pom
Summary:       Keycloak SAML Jetty Integration Parent POM

%description saml-jetty-integration-pom
Keycloak SAML Jetty Integration Parent POM.

%package saml-tomcat-integration-pom
Summary:       Keycloak SAML Tomcat Integration Parent POM

%description saml-tomcat-integration-pom
Keycloak SAML Tomcat Integration Parent POM.

%package saml-wildfly-integration-pom
Summary:       Keycloak SAML Wildfly Integration Parent POM

%description saml-wildfly-integration-pom
Keycloak SAML Wildfly Integration Parent POM.

%package tomcat-integration-pom
Summary:       Keycloak Tomcat Integration Parent POM

%description tomcat-integration-pom
Keycloak Tomcat Integration Parent POM.

%package util-embedded-ldap
Summary:       Keycloak Util Embedded LDAP

%description util-embedded-ldap
Keycloak Util Embedded LDAP.

%package util-parent
Summary:       Keycloak Util Parent POM

%description util-parent
Keycloak Util Parent POM.

%package wildfly-integration-pom
Summary:       Keycloak OIDC Wildfly Integration Parent POM

%description wildfly-integration-pom
Keycloak OIDC Wildfly Integration Parent POM.

%package wildfly-parent
Summary:       Keycloak WildFly Integration Parent POM

%description wildfly-parent
Keycloak WildFly Integration Parent POM.

%package js-adapter
Summary:       Keycloak JS Integration

%description js-adapter
Keycloak JavaScript Integration.

%if 0
%package themes
Summary:       Keycloak Themes
License:       ASL 2.0 and (ASL 2.0 and GPLv2+) and BSD and MIT and OFL
# Bundled javascript libraries
# License: MIT.
Provides:      bundled(js-angular) = 1.4.4
Provides:      bundled(js-angular-file-upload) = 1.1.10
Provides:      bundled(js-angular-scenario) = 2.1.1
Provides:      bundled(js-angular-translate) = 2.7.2
Provides:      bundled(js-angular-treeview) = 0.1.6
Provides:      bundled(js-angular-ui-ace) = 0.2.3
Provides:      bundled(js-angular-ui-bootstrap) = 0.11.0
Provides:      bundled(js-jquery) = 1.10.2
Provides:      bundled(js-jquery-angular-scenario) = 2.1.1
Provides:      bundled(js-jstd-scenario-adapter) = 1.0.5
# License: BSD.
Provides:      bundled(js-jquery-fileapi) = 1.2.5
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/fileupload/FileAPI.min.js
# License: X11/MIT.
Provides:      bundled(js-FileSave) = 1.3.2
# License: ASL 2.0.
Provides:      bundled(js-patternfly) = 3.0.2
# License: ASL 2.0 and GPL 2.0
Provides:      bundled(js-Select2) = 3.4.1

# Bundled fonts
# ran "ttname -a ..."
# License: ASL 2.0.
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-Bold-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-BoldItalic-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-ExtraBold-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-ExtraBoldItalic-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-Italic-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-Light-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-LightItalic-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-Regular-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-Semibold-webfont.{eot,svg,ttf,woff}
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/OpenSans-SemiboldItalic-webfont.{eot,svg,ttf,woff}
Provides:      bundled(open-sans-webfont) = 1.10
# ./themes/src/main/resources/theme/keycloak/common/resources/lib/patternfly/fonts/PatternFlyIcons-webfont.{eot,svg,ttf,woff}
Provides:      bundled(PatternFlyIcons-webfont) = 1.1
# License: OFL.
Provides:      bundled(fontawesome-fonts-web) = 4.3.0
# License: MIT.
Provides:      bundled(glyphicons-halflings-regular) = 1.009
# License: MIT.
Provides:      bundled(zocial-regular-webfont) = 001.000

%description themes
Keycloak Themes.
%endif

%if %{with jetty9}
%package jetty93-adapter
Summary:       Keycloak Jetty 9.3.x Integration

%description jetty93-adapter
Keycloak Jetty 9.3.x Integration.

%package saml-jetty93-adapter
Summary:       Keycloak Jetty 9.3.x SAML Integration

%description saml-jetty93-adapter
Keycloak Jetty 9.3.x SAML Integration.
%endif

%prep
%setup -q -n %{name}-%{namedversion}

%patch0 -p1
%if %{?fedora} <= 24
%patch1 -p1
%endif

# org.wildfly.bom:jboss-javaee-7.0-with-all:pom:8.0.0.Final 
%pom_remove_dep -r :jboss-javaee-7.0-with-all
# org.jboss.arquillian.selenium:selenium-bom:pom:2.52.0
%pom_remove_dep -r :selenium-bom
# org.jboss.arquillian.extension:arquillian-drone-bom:pom:2.0.0.Beta1
%pom_remove_dep -r :arquillian-drone-bom
# org.drools:drools-bom:pom:6.4.0.Final
%pom_remove_dep -r :drools-bom

# Useless
%pom_remove_plugin -r :maven-deploy-plugin

# Unsupported features
%pom_disable_module distribution
%pom_disable_module examples

%pom_disable_module testsuite
# Bundle different JavaScript libraries and fonts
%pom_disable_module themes
%pom_remove_dep :keycloak-themes dependencies/server-min

# com.samaxes.maven:minify-maven-plugin:1.7.2 
%pom_remove_plugin :minify-maven-plugin adapters/oidc/js

# org.springframework.boot:spring-boot-starter-web:1.2.1.RELEASE
%pom_disable_module spring-boot adapters/oidc

%pom_change_dep -r :catalina :tomcat-catalina adapters/oidc/tomcat/tomcat-core adapters/saml/tomcat/tomcat-core  adapters/spi/tomcat-adapter-spi

%pom_disable_module tomcat6 adapters/oidc/tomcat
%pom_disable_module tomcat7 adapters/oidc/tomcat
%pom_disable_module tomcat6 adapters/saml/tomcat
%pom_disable_module tomcat7 adapters/saml/tomcat

# org.jboss.web:jbossweb:7.0.17.Final
# org.jboss.as:jboss-as-web:7.1.2.Final
# org.jboss.as:jboss-as-controller,jboss-as-ee,jboss-as-naming,jboss-as-server,jboss-as-web:7.2.0.Final
%pom_disable_module as7-eap6 adapters/oidc
%pom_disable_module as7-eap6 adapters/saml

%pom_disable_module jetty9.1 adapters/oidc/jetty
%pom_disable_module jetty9.1 adapters/saml/jetty
%pom_disable_module jetty9.2 adapters/oidc/jetty
%pom_disable_module jetty9.2 adapters/saml/jetty
%if %{without jetty9}
%pom_disable_module jetty9.3 adapters/oidc/jetty
%pom_disable_module jetty9.3 adapters/saml/jetty
%endif

# org.osgi:org.osgi.enterprise:4.2.0
# org.ops4j.pax.web:pax-web-runtime:4.2.4
# org.ops4j.pax.web:pax-web-api:4.2.4
%pom_disable_module osgi-adapter adapters/oidc

# Use org.wildfly:wildfly-controller;wildfly-server:8.2.0.Final
%pom_disable_module wf8-subsystem adapters/oidc/wildfly
%if %{without wildfly}
# Use wildfly:10.0.0.Final
%pom_disable_module wildfly-subsystem adapters/oidc/wildfly
%pom_disable_module wildfly-subsystem adapters/saml/wildfly
%pom_disable_module server-subsystem wildfly
%endif

%if %{?fedora} < 25
%pom_disable_module infinispan model
%pom_remove_dep :keycloak-model-infinispan dependencies/server-all
%endif

# Default is set as 8.1.17.v20150415
%pom_xpath_set -r pom:properties/pom:jetty9.version 8.1 adapters/oidc/jetty/jetty-core adapters/oidc/jetty/jetty8.1 adapters/saml/jetty/jetty-core adapters/saml/jetty/jetty8.1 adapters/spi/jetty-adapter-spi

# NON free org.twitter4j:twitter4j-core:4.0.4
%pom_remove_dep :twitter4j-core services
rm -r services/src/main/java/org/keycloak/social/twitter
%pom_remove_dep :twitter4j-core dependencies/server-all

%pom_xpath_set -r pom:properties/pom:hibernate.entitymanager.version 5
%pom_change_dep :hibernate-entitymanager ::'${hibernate.entitymanager.version}' model/jpa

# org.drools:drools-core:6.4.0.Final
%pom_disable_module drools authz/policy
%pom_remove_dep -r org.keycloak:keycloak-authz-policy-drools
%pom_remove_dep org.kie:kie-api dependencies/server-all
%pom_remove_dep org.kie:kie-ci dependencies/server-all
%pom_remove_dep org.kie:kie-internal dependencies/server-all
%pom_remove_dep org.drools:drools-core dependencies/server-all
%pom_remove_dep org.drools:drools-compiler dependencies/server-all

%pom_xpath_set -r pom:properties/pom:log4j.version 1.2.17
%pom_change_dep -r log4j: ::'${log4j.version}'

%pom_remove_dep com.lowagie:itext dependencies/server-all
#%% pom_remove_dep com.google.inject.extensions:guice-servlet dependencies/server-all
%pom_remove_dep org.antlr:antlr-runtime dependencies/server-all
%pom_remove_dep org.apache.maven.wagon:wagon-http dependencies/server-all
%pom_remove_dep org.apache.maven.wagon:wagon-http-shared dependencies/server-all
%pom_remove_dep org.eclipse.aether:aether-transport-wagon dependencies/server-all
%pom_remove_dep org.sonatype.sisu:sisu-guice dependencies/server-all
%pom_remove_dep org.mvel:mvel2 dependencies/server-all

%pom_remove_dep org.jboss.integration-platform:jboss-integration-platform-bom dependencies/server-all

# Only this module use aesh:0.66.10
%pom_disable_module client-registration-cli integration/client-cli
%pom_disable_module client-cli integration
%pom_remove_dep -r :keycloak-client-registration-cli

# Disable jna copy
%pom_remove_plugin :maven-shade-plugin federation/sssd

sed -i.trailing_commas "s|redirectUri: encodeURIComponent(redirectUri),|redirectUri: encodeURIComponent(redirectUri)|" \
 adapters/oidc/js/src/main/resources/keycloak.js

# spurious-executable-perm
chmod 644 README.md License.html
# Error occurred during initialization of VM
# Could not reserve enough space for 2097152KB object heap
# The forked VM terminated without properly saying goodbye.
# VM crash or System.exit called?
sed -i "s|Xmx2048m|Xmx1024m|" pom.xml
# com.icegreen:greenmail:1.3.1b
%pom_remove_dep :greenmail services

# ERROR POMs: dependency must be unique
%pom_remove_dep org.jboss.logging:jboss-logging adapters/saml/undertow
%pom_add_dep org.jboss.logging:jboss-logging:'${jboss.logging.version}':provided adapters/saml/undertow

%build

(
 cd adapters/oidc/js/src/main/resources
 closure-compiler --js keycloak.js --js_output_file keycloak-min.js --charset utf-8
 closure-compiler --js keycloak-authz.js --js_output_file keycloak-authz-min.js --charset utf-8
 mv keycloak-min.js keycloak.js
 mv keycloak-authz-min.js keycloak-authz.js
)

%mvn_build -s

%install
%mvn_install

%files adapter-core -f .mfiles-keycloak-adapter-core
%files adapter-spi -f .mfiles-keycloak-adapter-spi
%files admin-client -f .mfiles-keycloak-admin-client
%files authz-client -f .mfiles-keycloak-authz-client
%files authz-policy-common -f .mfiles-keycloak-authz-policy-common
%files client-registration-api -f .mfiles-keycloak-client-registration-api
%files common -f .mfiles-keycloak-common
%doc README.md
%license License.html

%files model-mongo -f .mfiles-keycloak-model-mongo
%files spring-security-adapter -f .mfiles-keycloak-spring-security-adapter

%files core -f .mfiles-keycloak-core
%files installed-adapter -f .mfiles-keycloak-installed-adapter
%files jaxrs-oauth-client -f .mfiles-keycloak-jaxrs-oauth-client
%files jboss-adapter-core -f .mfiles-keycloak-jboss-adapter-core
%files jetty-adapter-spi -f .mfiles-keycloak-jetty-adapter-spi
%files jetty-core -f .mfiles-keycloak-jetty-core
%files jetty81-adapter -f .mfiles-keycloak-jetty81-adapter
%files kerberos-federation -f .mfiles-keycloak-kerberos-federation
%files ldap-federation -f .mfiles-keycloak-ldap-federation

%if %{?fedora} >= 25
%files model-infinispan -f .mfiles-keycloak-model-infinispan
%endif

%if %{with jetty9}
%files jetty93-adapter -f .mfiles-keycloak-jetty93-adapter
%files saml-jetty93-adapter -f .mfiles-keycloak-saml-jetty93-adapter

%endif

%files model-jpa -f .mfiles-keycloak-model-jpa
%files proxy-server -f .mfiles-keycloak-proxy-server
%files saml-adapter-api-public -f .mfiles-keycloak-saml-adapter-api-public
%files saml-adapter-core -f .mfiles-keycloak-saml-adapter-core
%files saml-core-public -f .mfiles-keycloak-saml-core-public
%files saml-core -f .mfiles-keycloak-saml-core
%files saml-jetty-adapter-core -f .mfiles-keycloak-saml-jetty-adapter-core
%files saml-jetty81-adapter -f .mfiles-keycloak-saml-jetty81-adapter
%files saml-servlet-filter-adapter -f .mfiles-keycloak-saml-servlet-filter-adapter
%files saml-tomcat-adapter-core -f .mfiles-keycloak-saml-tomcat-adapter-core
%files saml-tomcat8-adapter -f .mfiles-keycloak-saml-tomcat8-adapter
%files saml-undertow-adapter -f .mfiles-keycloak-saml-undertow-adapter
%files saml-wildfly-adapter -f .mfiles-keycloak-saml-wildfly-adapter
%files server-spi -f .mfiles-keycloak-server-spi
%files server-spi-private -f .mfiles-keycloak-server-spi-private
%files services -f .mfiles-keycloak-services
%files servlet-adapter-spi -f .mfiles-keycloak-servlet-adapter-spi
%files servlet-filter-adapter -f .mfiles-keycloak-servlet-filter-adapter
%files servlet-oauth-client -f .mfiles-keycloak-servlet-oauth-client
%files sssd-federation -f .mfiles-keycloak-sssd-federation
%license federation/sssd/src/main/resources/DBUS-JAVA-LICENSE

%files tomcat-adapter-spi -f .mfiles-keycloak-tomcat-adapter-spi
%files tomcat-core-adapter -f .mfiles-keycloak-tomcat-core-adapter
%files tomcat8-adapter -f .mfiles-keycloak-tomcat8-adapter
%files undertow-adapter-spi -f .mfiles-keycloak-undertow-adapter-spi
%files undertow-adapter -f .mfiles-keycloak-undertow-adapter
%files launcher -f .mfiles-launcher

%files adapters-pom -f .mfiles-keycloak-adapters-pom
%license License.html

%files authz-parent -f .mfiles-keycloak-authz-parent
%license License.html

%files authz-provider-parent -f .mfiles-keycloak-authz-provider-parent
%license License.html

%files client-adapter-spi-pom -f .mfiles-keycloak-client-adapter-spi-pom
%license License.html

%files dependencies-parent -f .mfiles-keycloak-dependencies-parent
%license License.html

%files dependencies-server-all -f .mfiles-keycloak-dependencies-server-all
%license License.html

%files dependencies-server-min -f .mfiles-keycloak-dependencies-server-min
%license License.html

%files federation-parent -f .mfiles-keycloak-federation-parent
%license License.html

%files integration-parent -f .mfiles-keycloak-integration-parent
%license License.html

%files javadoc -f .mfiles-javadoc
%license License.html

%files jetty-integration-pom -f .mfiles-keycloak-jetty-integration-pom
%license License.html

%files model-pom -f .mfiles-keycloak-model-pom
%license License.html

%files oidc-client-adapter-pom -f .mfiles-keycloak-oidc-client-adapter-pom
%license License.html

%files parent -f .mfiles-keycloak-parent
%license License.html

%files proxy-pom -f .mfiles-keycloak-proxy-pom
%license License.html

%files saml-client-adapter-pom -f .mfiles-keycloak-saml-client-adapter-pom
%license License.html

%files saml-jetty-integration-pom -f .mfiles-keycloak-saml-jetty-integration-pom
%license License.html

%files saml-tomcat-integration-pom -f .mfiles-keycloak-saml-tomcat-integration-pom
%license License.html

%files saml-wildfly-integration-pom -f .mfiles-keycloak-saml-wildfly-integration-pom
%license License.html

%files tomcat-integration-pom -f .mfiles-keycloak-tomcat-integration-pom
%license License.html

%files util-embedded-ldap -f .mfiles-keycloak-util-embedded-ldap
%files util-parent -f .mfiles-keycloak-util-parent
%license License.html

%files wildfly-adapter -f .mfiles-keycloak-wildfly-adapter
%files wildfly-adduser -f .mfiles-keycloak-wildfly-adduser
%files wildfly-extensions -f .mfiles-keycloak-wildfly-extensions
%files wildfly-integration-pom -f .mfiles-keycloak-wildfly-integration-pom
%license License.html

%files wildfly-parent -f .mfiles-keycloak-wildfly-parent
%license License.html

%if %{with wildfly}
%files saml-wildfly-subsystem -f .mfiles-keycloak-saml-wildfly-subsystem
%files wildfly-server-subsystem -f .mfiles-keycloak-wildfly-server-subsystem
%files wildfly-subsystem -f .mfiles-keycloak-wildfly-subsystem
%endif

%files js-adapter -f .mfiles-keycloak-js-adapter
%license License.html

%changelog
* Sat Nov 26 2016 gil cattaneo <puntogil@libero.it> 2.4.0-1
- update to 2.4.0.Final

* Mon Nov 07 2016 gil cattaneo <puntogil@libero.it> 2.3.0-1
- update to 2.3.0.Final

* Thu Oct 13 2016 gil cattaneo <puntogil@libero.it> 2.2.1-1
- update to 2.2.1.Final

* Sun Sep 04 2016 gil cattaneo <puntogil@libero.it> 1.9.8-1
- update to 1.9.8.Final

* Sun Jun 12 2016 gil cattaneo <puntogil@libero.it> 1.9.7-1
- initial rpm
